# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from cobo_waas2.models.app_workflow_policy import AppWorkflowPolicy
from typing import Optional, Set
from typing_extensions import Self


class AppWorkflow(BaseModel):
    """
    The information of an app workflow approval user entry.
    """  # noqa: E501
    workflow_id: StrictStr = Field(description="The workflow id.")
    operation_id: StrictStr = Field(description="The workflow operation id.")
    operation_name: StrictStr = Field(description="The workflow operation name.")
    current_policies: List[AppWorkflowPolicy]
    __properties: ClassVar[List[str]] = ["workflow_id", "operation_id", "operation_name", "current_policies"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AppWorkflow from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in current_policies (list)
        _items = []
        if self.current_policies:
            for _item in self.current_policies:
                if _item:
                    _items.append(_item.to_dict())
            _dict['current_policies'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AppWorkflow from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "workflow_id": obj.get("workflow_id"),
            "operation_id": obj.get("operation_id"),
            "operation_name": obj.get("operation_name"),
            "current_policies": [AppWorkflowPolicy.from_dict(_item) for _item in obj["current_policies"]] if obj.get("current_policies") is not None else None
        })
        return _obj


