# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cobo_waas2.models.replace_type import ReplaceType
from typing import Optional, Set
from typing_extensions import Self


class TransactionReplacement(BaseModel):
    """
    TransactionReplacement
    """  # noqa: E501
    replaced_by_type: Optional[ReplaceType] = None
    replaced_by_transaction_id: Optional[StrictStr] = Field(default=None, description="The ID of the transaction that this transaction was replaced by.")
    replaced_by_transaction_hash: Optional[StrictStr] = Field(default=None, description="The hash of the transaction that this transaction was replaced by.")
    replaced_type: Optional[ReplaceType] = None
    replaced_transaction_id: Optional[StrictStr] = Field(default=None, description="The ID of the transaction that this transaction replaced.")
    replaced_transaction_hash: Optional[StrictStr] = Field(default=None, description="The hash of the transaction that this transaction replaced.")
    __properties: ClassVar[List[str]] = ["replaced_by_type", "replaced_by_transaction_id", "replaced_by_transaction_hash", "replaced_type", "replaced_transaction_id", "replaced_transaction_hash"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransactionReplacement from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransactionReplacement from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "replaced_by_type": obj.get("replaced_by_type"),
            "replaced_by_transaction_id": obj.get("replaced_by_transaction_id"),
            "replaced_by_transaction_hash": obj.get("replaced_by_transaction_hash"),
            "replaced_type": obj.get("replaced_type"),
            "replaced_transaction_id": obj.get("replaced_transaction_id"),
            "replaced_transaction_hash": obj.get("replaced_transaction_hash")
        })
        return _obj


