# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cobo_waas2.models.transaction_approval_result import TransactionApprovalResult
from typing import Optional, Set
from typing_extensions import Self


class TransactionUserApprovalDetail(BaseModel):
    """
    The user approval data for transaction.
    """  # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="The name of the user who audited this message.")
    email: Optional[StrictStr] = Field(default=None, description="The email of the user who audited this message.")
    pubkey: Optional[StrictStr] = Field(default=None, description="The Cobo Guard public key of the user who audited this message.")
    result: Optional[TransactionApprovalResult] = None
    signature: Optional[StrictStr] = Field(default=None, description="The signature of the audited message.")
    language: Optional[StrictStr] = Field(default=None, description="The language of the audited message.")
    message_version: Optional[StrictStr] = Field(default=None, description="The version of the audited message.")
    message: Optional[StrictStr] = Field(default=None, description="The audited message.")
    extra_message: Optional[StrictStr] = Field(default=None, description="The extra audited message.")
    __properties: ClassVar[List[str]] = ["name", "email", "pubkey", "result", "signature", "language", "message_version", "message", "extra_message"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransactionUserApprovalDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransactionUserApprovalDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "email": obj.get("email"),
            "pubkey": obj.get("pubkey"),
            "result": obj.get("result"),
            "signature": obj.get("signature"),
            "language": obj.get("language"),
            "message_version": obj.get("message_version"),
            "message": obj.get("message"),
            "extra_message": obj.get("extra_message")
        })
        return _obj


