# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cobo_waas2.models.selected_entity_type import SelectedEntityType
from typing import Optional, Set
from typing_extensions import Self


class TravelRuleWithdrawNaturalEntity(BaseModel):
    """
    The required information of a natural person.
    """  # noqa: E501
    selected_entity_type: SelectedEntityType
    first_name: StrictStr = Field(description="The first name of the natural person.")
    last_name: StrictStr = Field(description="The last name of the natural person.")
    date_of_birth: Optional[date] = Field(default=None, description="The date of birth of the natural person.")
    place_of_birth: Optional[StrictStr] = Field(default=None, description="The place of birth of the natural person.")
    __properties: ClassVar[List[str]] = ["selected_entity_type", "first_name", "last_name", "date_of_birth", "place_of_birth"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TravelRuleWithdrawNaturalEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TravelRuleWithdrawNaturalEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "selected_entity_type": obj.get("selected_entity_type"),
            "first_name": obj.get("first_name"),
            "last_name": obj.get("last_name"),
            "date_of_birth": obj.get("date_of_birth"),
            "place_of_birth": obj.get("place_of_birth")
        })
        return _obj


