# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from cobo_waas2.models.key_share_holder_group import KeyShareHolderGroup
from cobo_waas2.models.mpc_project import MPCProject
from cobo_waas2.models.mpc_vault import MPCVault
from cobo_waas2.models.mpc_wallet_info import MPCWalletInfo
from cobo_waas2.models.org_info import OrgInfo
from typing import Optional, Set
from typing_extensions import Self


class TSSKeyShareSignExtra(BaseModel):
    """
    TSSKeyShareSignExtra
    """  # noqa: E501
    org: Optional[OrgInfo] = None
    project: Optional[MPCProject] = None
    vault: Optional[MPCVault] = None
    wallet: Optional[MPCWalletInfo] = None
    validity_key_share_holder_groups: Optional[List[KeyShareHolderGroup]] = None
    __properties: ClassVar[List[str]] = ["org", "project", "vault", "wallet", "validity_key_share_holder_groups"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TSSKeyShareSignExtra from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of org
        if self.org:
            _dict['org'] = self.org.to_dict()
        # override the default output from pydantic by calling `to_dict()` of project
        if self.project:
            _dict['project'] = self.project.to_dict()
        # override the default output from pydantic by calling `to_dict()` of vault
        if self.vault:
            _dict['vault'] = self.vault.to_dict()
        # override the default output from pydantic by calling `to_dict()` of wallet
        if self.wallet:
            _dict['wallet'] = self.wallet.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in validity_key_share_holder_groups (list)
        _items = []
        if self.validity_key_share_holder_groups:
            for _item in self.validity_key_share_holder_groups:
                if _item:
                    _items.append(_item.to_dict())
            _dict['validity_key_share_holder_groups'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TSSKeyShareSignExtra from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "org": OrgInfo.from_dict(obj["org"]) if obj.get("org") is not None else None,
            "project": MPCProject.from_dict(obj["project"]) if obj.get("project") is not None else None,
            "vault": MPCVault.from_dict(obj["vault"]) if obj.get("vault") is not None else None,
            "wallet": MPCWalletInfo.from_dict(obj["wallet"]) if obj.get("wallet") is not None else None,
            "validity_key_share_holder_groups": [KeyShareHolderGroup.from_dict(_item) for _item in obj["validity_key_share_holder_groups"]] if obj.get("validity_key_share_holder_groups") is not None else None
        })
        return _obj


