# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class WebhookEventType(str, Enum):
    """
    The event type. To learn the trigger condition of each event type, refer to [Webhook event types and event data](https://www.cobo.com/developers/v2/guides/webhooks-callbacks/webhook-event-type).
    """

    """
    allowed enum values
    """
    WALLETS_DOT_TRANSACTION_DOT_CREATED = 'wallets.transaction.created'
    WALLETS_DOT_TRANSACTION_DOT_UPDATED = 'wallets.transaction.updated'
    WALLETS_DOT_TRANSACTION_DOT_FAILED = 'wallets.transaction.failed'
    WALLETS_DOT_TRANSACTION_DOT_SUCCEEDED = 'wallets.transaction.succeeded'
    WALLETS_DOT_MPC_DOT_TSS_REQUEST_DOT_CREATED = 'wallets.mpc.tss_request.created'
    WALLETS_DOT_MPC_DOT_TSS_REQUEST_DOT_UPDATED = 'wallets.mpc.tss_request.updated'
    WALLETS_DOT_MPC_DOT_TSS_REQUEST_DOT_FAILED = 'wallets.mpc.tss_request.failed'
    WALLETS_DOT_MPC_DOT_TSS_REQUEST_DOT_SUCCEEDED = 'wallets.mpc.tss_request.succeeded'
    WALLETS_DOT_ADDRESSES_DOT_CREATED = 'wallets.addresses.created'
    WALLETS_DOT_CREATED = 'wallets.created'
    WALLETS_DOT_TOKEN_LISTING_DOT_FAILED = 'wallets.token_listing.failed'
    WALLETS_DOT_TOKEN_LISTING_DOT_SUCCEEDED = 'wallets.token_listing.succeeded'
    MPC_VAULTS_DOT_CREATED = 'mpc_vaults.created'
    FEE_STATION_DOT_TRANSACTION_DOT_CREATED = 'fee_station.transaction.created'
    FEE_STATION_DOT_TRANSACTION_DOT_UPDATED = 'fee_station.transaction.updated'
    FEE_STATION_DOT_TRANSACTION_DOT_FAILED = 'fee_station.transaction.failed'
    FEE_STATION_DOT_TRANSACTION_DOT_SUCCEEDED = 'fee_station.transaction.succeeded'
    WALLET_DOT_TOKEN_DOT_ENABLED = 'wallet.token.enabled'
    WALLET_DOT_CHAIN_DOT_ENABLED = 'wallet.chain.enabled'
    PAYMENT_DOT_TRANSACTION_DOT_CREATED = 'payment.transaction.created'
    PAYMENT_DOT_TRANSACTION_DOT_LATE = 'payment.transaction.late'
    PAYMENT_DOT_TRANSACTION_DOT_HELD = 'payment.transaction.held'
    PAYMENT_DOT_STATUS_DOT_UPDATED = 'payment.status.updated'
    PAYMENT_DOT_REFUND_DOT_STATUS_DOT_UPDATED = 'payment.refund.status.updated'
    PAYMENT_DOT_SETTLEMENT_DOT_STATUS_DOT_UPDATED = 'payment.settlement.status.updated'

    UNKNOWN = None

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of WebhookEventType from a JSON string"""
        return cls(json.loads(json_str))

    @classmethod
    def _missing_(cls, value):
        return cls.UNKNOWN


